(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('prop-types'), require('immer')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'prop-types', 'immer'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.ReactEvoke = {}, global.React, global.PropTypes, global.produce));
}(this, (function (exports, React, PropTypes, produce) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
  var PropTypes__default = /*#__PURE__*/_interopDefaultLegacy(PropTypes);
  var produce__default = /*#__PURE__*/_interopDefaultLegacy(produce);

  function _typeof(obj) {
    "@babel/helpers - typeof";

    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function (obj) {
        return typeof obj;
      };
    } else {
      _typeof = function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _construct(Parent, args, Class) {
    if (_isNativeReflectConstruct()) {
      _construct = Reflect.construct;
    } else {
      _construct = function _construct(Parent, args, Class) {
        var a = [null];
        a.push.apply(a, args);
        var Constructor = Function.bind.apply(Parent, a);
        var instance = new Constructor();
        if (Class) _setPrototypeOf(instance, Class.prototype);
        return instance;
      };
    }

    return _construct.apply(null, arguments);
  }

  function _isNativeFunction(fn) {
    return Function.toString.call(fn).indexOf("[native code]") !== -1;
  }

  function _wrapNativeSuper(Class) {
    var _cache = typeof Map === "function" ? new Map() : undefined;

    _wrapNativeSuper = function _wrapNativeSuper(Class) {
      if (Class === null || !_isNativeFunction(Class)) return Class;

      if (typeof Class !== "function") {
        throw new TypeError("Super expression must either be null or a function");
      }

      if (typeof _cache !== "undefined") {
        if (_cache.has(Class)) return _cache.get(Class);

        _cache.set(Class, Wrapper);
      }

      function Wrapper() {
        return _construct(Class, arguments, _getPrototypeOf(this).constructor);
      }

      Wrapper.prototype = Object.create(Class.prototype, {
        constructor: {
          value: Wrapper,
          enumerable: false,
          writable: true,
          configurable: true
        }
      });
      return _setPrototypeOf(Wrapper, Class);
    };

    return _wrapNativeSuper(Class);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();

    return function _createSuperInternal() {
      var Super = _getPrototypeOf(Derived),
          result;

      if (hasNativeReflectConstruct) {
        var NewTarget = _getPrototypeOf(this).constructor;

        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }

      return _possibleConstructorReturn(this, result);
    };
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
  }

  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  produce.enablePatches();

  function isPromise(obj) {
    return !!obj && (_typeof(obj) === "object" || typeof obj === "function") && typeof obj.then === "function";
  }

  var ALL_ITEMS = undefined;
  var UNINITIALIZED = null;
  var MAX_SIGNED_31_BIT_INT = Math.pow(2, 30) - 1; // 0b111111111111111111111111111111

  var UninitializedError = /*#__PURE__*/function (_Error) {
    _inherits(UninitializedError, _Error);

    var _super = _createSuper(UninitializedError);

    function UninitializedError(name, item) {
      var _this;

      _classCallCheck(this, UninitializedError);

      _this = _super.call(this);
      _this.uninitializedName = name;
      _this.uninitializedItem = item;
      return _this;
    }

    return UninitializedError;
  }( /*#__PURE__*/_wrapNativeSuper(Error));

  var shallowEqual = function shallowEqual(obj1, obj2) {
    var keys = Object.keys(obj1);
    return keys.length === Object.keys(obj2).length && keys.every(function (key) {
      return obj1[key] === obj2[key];
    });
  };

  function memoizeDeriver(select, derive) {
    var lastState = null;
    var lastValue = null;
    return function (getState, item) {
      var state = select(getState, item);

      if (!(lastState && shallowEqual(state, lastState))) {
        lastValue = derive(state);
      }

      lastState = state;
      return lastValue;
    };
  }

  var createStore = function createStore(defaultProps) {
    var NAME_COUNT = 0;
    var NAME_BITS = {}; // calculate changed bits for StoreContext, whose value is
    // { state, actions, register, read }

    function calculateChangedBits(_ref, _ref2) {
      var prevState = _ref.state;
      var nextState = _ref2.state;
      var mask = 0;

      for (var id in nextState) {
        if (prevState[id] !== nextState[id]) {
          mask |= getObservedBits(id);
        }
      }

      return mask;
    } // get the observed bits (bitmask) for a given top-level name
    // note: every 32nd name will share a bitmask


    function getObservedBits(name, item) {
      if (NAME_BITS.hasOwnProperty(name)) {
        return NAME_BITS[name];
      } else {
        var bits = 1 << NAME_COUNT++ % 30;
        return NAME_BITS[name] = bits;
      }
    } // create context for sharing THIS store


    var StoreContext = /*#__PURE__*/React__default['default'].createContext(undefined, calculateChangedBits); // Store component

    var Store = /*#__PURE__*/function (_React$Component) {
      _inherits(Store, _React$Component);

      var _super2 = _createSuper(Store);

      function Store(props) {
        var _this2;

        _classCallCheck(this, Store);

        _this2 = _super2.call(this, props);

        _defineProperty(_assertThisInitialized(_this2), "register", function (actions) {
          Object.keys(actions).forEach(function (actionName) {
            var action = actions[actionName];

            if (!_this2.registry.hasOwnProperty(actionName)) {
              _this2.registry[actionName] = new Set();

              _this2.actions[actionName] = function () {
                for (var _len = arguments.length, payload = new Array(_len), _key = 0; _key < _len; _key++) {
                  payload[_key] = arguments[_key];
                }

                return _this2.dispatch(actionName, payload);
              };
            }

            _this2.registry[actionName].add(action);
          });
        });

        _defineProperty(_assertThisInitialized(_this2), "dispatch", function (actionName, payload, extraInfo) {
          var dispatchId = _this2._dispatchId++;

          if (_this2.registry.hasOwnProperty(actionName)) {
            // only provide a public Store interface to actions
            var store = {
              update: _this2.update,
              getState: _this2.getState,
              actions: _this2.actions,
              meta: _this2.meta
            }; // pass along related information for logging etc.

            var info = _objectSpread2({
              actionName: actionName,
              dispatchId: dispatchId
            }, extraInfo); // create an function to execute all handlers registered
            // for an action


            var action = function action(store) {
              for (var _len2 = arguments.length, payload = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                payload[_key2 - 1] = arguments[_key2];
              }

              var promises = [];

              _this2.registry[actionName].forEach(function (handler // Set.forEach for IE11
              ) {
                return promises.push(handler.apply(void 0, [store].concat(payload)));
              });

              return Promise.all(promises).then(function (values) {
                return Object.assign.apply(Object, [Object.defineProperty({}, "dispatchId", {
                  value: dispatchId,
                  enumerable: false
                })].concat(_toConsumableArray(values.map(function (v) {
                  return v || {};
                }))));
              }).catch(function (error) {
                if (error) {
                  if (!error.hasOwnProperty("dispatchId")) {
                    Object.defineProperty(error, "dispatchId", {
                      value: dispatchId,
                      enumerable: false
                    });
                  }
                }

                throw error;
              });
            }; // assemble middleware


            var middleware = function middleware(action, info) {
              return function (store) {
                for (var _len3 = arguments.length, payload = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
                  payload[_key3 - 1] = arguments[_key3];
                }

                return action.apply(void 0, [store].concat(payload));
              };
            };

            if (_this2.props.middleware && _this2.props.middleware.length > 0) {
              middleware = function middleware(action, info) {
                return _this2.props.middleware.reduce(function (prevHandler, nextMiddleware) {
                  return nextMiddleware(prevHandler, info);
                }, action);
              };
            } // execute middleware-wrapped action


            return middleware(action, info).apply(void 0, [store].concat(_toConsumableArray(payload)));
          } else {
            if (process.env.NODE_ENV !== "production") {
              console.warn("Unregistered action ".concat(actionName, " dispatched"));
            }

            return Promise.resolve(null); // ignore undeclared actions
          }
        });

        _defineProperty(_assertThisInitialized(_this2), "getState", function (name, item) {
          // provide abstract public interface for read-only access state
          // (in case we change how we manage it. for example, we may use
          // react-cache when it supports invalidation).
          if (name) {
            if (item) {
              if (_this2.state.state.hasOwnProperty(name)) {
                return _this2.state.state[name][item];
              } else {
                return undefined;
              }
            } else {
              return _this2.state.state[name];
            }
          } else {
            return _this2.state.state;
          }
        });

        _defineProperty(_assertThisInitialized(_this2), "registerDerivedState", function (derivedState) {
          Object.keys(derivedState).forEach(function (name) {
            var deriver = derivedState[name];

            if (Array.isArray(deriver)) {
              _this2.derivedState[name] = memoizeDeriver.apply(void 0, _toConsumableArray(deriver));
            } else {
              _this2.derivedState[name] = deriver;
            }

            NAME_BITS[name] = MAX_SIGNED_31_BIT_INT; // dependent on everything until first executed
          });
        });

        _defineProperty(_assertThisInitialized(_this2), "read", function (name) {
          var item = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : ALL_ITEMS;

          // short-circuit return when already initialized
          if (_this2.state.state.hasOwnProperty(name) && _this2.state.state[name] != UNINITIALIZED // eslint-disable-line eqeqeq
          ) {
              if (item === ALL_ITEMS) {
                return _this2.state.state[name];
              } else if (_this2.state.state[name].hasOwnProperty(item)) {
                return _this2.state.state[name][item];
              } // otherwise this.state.state[name][item] isn't initialized

            } // value isn't in store, check for derived state


          if (_this2.derivedState.hasOwnProperty(name)) {
            var mask = 0;

            var getState = function getState(name, item) {
              mask |= getObservedBits(name);

              var value = _this2.getState(name, item); // eslint-disable-next-line eqeqeq


              if (value == UNINITIALIZED) {
                throw new UninitializedError(name, item);
              } else {
                return value;
              }
            };

            try {
              var derivedValue = _this2.derivedState[name](getState, item);

              if (process.env.NODE_ENV !== "production") {
                if (isPromise(derivedValue)) {
                  console.error("derivedState state functions cannot be async, please do async work in actions");
                  throw new Error("Invalid derivedState");
                }
              }

              NAME_BITS[name] = mask; // update derivedState bitmask w/dependencies

              return derivedValue;
            } catch (error) {
              if (error instanceof UninitializedError) {
                name = error.uninitializedName;
                item = error.uninitializedItem;
              } else {
                throw error;
              }
            }
          } // get initialization action


          var actionName = _this2.props.initializers[name];

          if (!actionName) {
            if (item === ALL_ITEMS) {
              throw Error("Cannot use undefined ".concat(name, " without Store initializer for ").concat(name));
            } else {
              throw Error("Cannot use undefined ".concat(name, "[").concat(item, "] without Store initializer for ").concat(name, " with payload ").concat(item));
            }
          } // create temporary cache for pending initialization


          if (!_this2._pendingInitializations.hasOwnProperty(name)) {
            _this2._pendingInitializations[name] = {};
          }

          var cache = _this2._pendingInitializations[name]; // retrieve pending cache state for this item

          var cacheKeyForItem = item; // could be ALL_ITEMS (=== undefined)

          var value = cache[cacheKeyForItem];

          if (value === undefined || value === true && (!_this2.state.state.hasOwnProperty(name) || _this2.state.state[name] == UNINITIALIZED) // eslint-disable-line eqeqeq
          ) {
              // if there is no pending cache entry for this item
              // OR it resolved without error and state still uninitialized
              // warning: we may not want to be this lenient but it can be helpful
              // for signaling that a retry is worthwhile
              var promise = new Promise(function (resolve) {
                return (// avoid updating state during existing state transition by deferring dispatch
                  // until after promise is thrown and the calling render function exits.
                  // https://developer.mozilla.org/en-US/docs/Web/JavaScript/EventLoop#Zero_delays
                  setTimeout(resolve, 0)
                );
              }).then(function () {
                return _this2.dispatch(actionName, [item], {
                  initializing: name
                });
              }).then(function () {
                // eslint-disable-next-line eqeqeq
                if (_this2.state.state[name] == UNINITIALIZED) {
                  // prevent infinite loop with faulty initializer
                  if (item === ALL_ITEMS) {
                    console.error("Initializer ".concat(actionName, " didn't initialize ").concat(name, "]!"));

                    _this2.setState(function (prevState) {
                      return _objectSpread2(_objectSpread2({}, prevState), {}, _defineProperty({}, name, {}));
                    });
                  } else {
                    console.error("Initializer ".concat(actionName, "(").concat(item, ") didn't initialize ").concat(name, "[").concat(item, "]!"));

                    _this2.setState(function (prevState) {
                      return _objectSpread2(_objectSpread2({}, prevState), {}, _defineProperty({}, name, _objectSpread2(_objectSpread2({}, prevState[name] || {}), {}, _defineProperty({}, item, {}))));
                    });
                  }
                }
              }); // put pending promise in the cache

              cache[cacheKeyForItem] = promise; // suspend render and update cache when resolved

              throw promise.then(function (value) {
                cache[cacheKeyForItem] = true;
              }, function (error) {
                cache[cacheKeyForItem] = error;
              });
            } else {
            // item already in pending initialization cache
            if (isPromise(value)) {
              // re-suspend with pending initializer promise
              throw value;
            } else if (value === true) {
              // noop throw to trigger short-circuit/synchronous read
              throw Promise.resolve();
            } else {
              // throw initializer error to error boundary
              if (!value.hasOwnProperty("isInitializer")) {
                value = Object.defineProperty(value, "isInitializer", {
                  value: true,
                  enumerable: false
                });
              }

              var clear = function clear() {
                delete cache[cacheKeyForItem];
              };

              if (!value.hasOwnProperty("clear")) {
                value = Object.defineProperty(value, "clear", {
                  value: clear,
                  writable: true,
                  enumerable: false
                });
              } else {
                value.clear = clear;
              }

              throw value;
            }
          }
        });

        _defineProperty(_assertThisInitialized(_this2), "update", function (mutator) {
          return (// use immer copy-on-write (mutate draft) semantics to update current state
            new Promise(function (resolve) {
              var changes = [];
              var reverts = [];
              produce.enableES5();

              _this2.setState(function (prevState) {
                var nextState = produce__default['default'](prevState, function (draftState) {
                  return mutator(draftState.state);
                }, function (p, r) {
                  changes.push.apply(changes, _toConsumableArray(p));
                  reverts.push.apply(reverts, _toConsumableArray(r));
                });
                return nextState;
              }, function () {
                return resolve({
                  changes: changes,
                  reverts: reverts
                });
              });
            })
          );
        });

        _this2.actions = {};
        _this2.registry = {};

        _this2.register(props.actions);

        if (props.initialState) {
          _this2.state = {
            state: _objectSpread2({}, props.initialState),
            actions: _this2.actions,
            register: _this2.register,
            read: _this2.read
          };
        } else {
          _this2.state = {
            state: {},
            actions: _this2.actions,
            register: _this2.register,
            read: _this2.read
          };
        }

        _this2.derivedState = {};

        if (props.derivedState) {
          _this2.registerDerivedState(props.derivedState);
        } // meta state (api objects, etc.) -- mutable!


        _this2.meta = props.meta || {}; // internal tracking

        _this2._pendingInitializations = {};
        _this2._dispatchId = 1;
        return _this2;
      }

      _createClass(Store, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          if (this.props.setup) {
            this.actions[this.props.setup]();
          }
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          if (this.props.teardown) {
            this.actions[this.props.teardown]();
          } // alert developer of an unmount during a pending initialization so they can
          // add the missing Suspense component


          if (process.env.NODE_ENV !== "production") if (Object.keys(this._pendingInitializations).length) {
            console.error("Store unmounted during initialization. Its subtree might be missing a Suspense or an ErrorBoundary component.");
          }
        }
      }, {
        key: "componentDidUpdate",
        value: function componentDidUpdate() {
          var _this3 = this;

          // clear pending initializations if resolved after Store update
          Object.keys(this._pendingInitializations).forEach(function (name) {
            Object.keys(_this3._pendingInitializations[name]).forEach(function (item) {
              if (_this3._pendingInitializations[name][item] === true) {
                // only delete successfully resolved promises, leave
                // pending promises and errors
                delete _this3._pendingInitializations[name][item];

                if (!Object.keys(_this3._pendingInitializations[name]).length) {
                  delete _this3._pendingInitializations[name];
                }
              }
            });
          });
        }
      }, {
        key: "render",
        value: function render() {
          return /*#__PURE__*/React__default['default'].createElement(StoreContext.Provider, {
            value: this.state
          }, this.props.children);
        }
      }]);

      return Store;
    }(React__default['default'].Component);

    _defineProperty(Store, "propTypes", {
      actions: PropTypes__default['default'].object,
      initializers: PropTypes__default['default'].object,
      initialState: PropTypes__default['default'].object,
      derivedState: PropTypes__default['default'].object,
      setup: PropTypes__default['default'].string,
      teardown: PropTypes__default['default'].string,
      middleware: PropTypes__default['default'].arrayOf(PropTypes__default['default'].func),
      meta: PropTypes__default['default'].object
    });

    _defineProperty(Store, "defaultProps", defaultProps);

    var ErrorBoundary = /*#__PURE__*/function (_React$Component2) {
      _inherits(ErrorBoundary, _React$Component2);

      var _super3 = _createSuper(ErrorBoundary);

      function ErrorBoundary() {
        var _this4;

        _classCallCheck(this, ErrorBoundary);

        for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
          args[_key4] = arguments[_key4];
        }

        _this4 = _super3.call.apply(_super3, [this].concat(args));

        _defineProperty(_assertThisInitialized(_this4), "state", {
          error: null
        });

        _defineProperty(_assertThisInitialized(_this4), "clearError", function () {
          if (_this4.state.error.isInitializer) {
            _this4.state.error.clear();
          }

          _this4.setState({
            error: null
          });
        });

        return _this4;
      }

      _createClass(ErrorBoundary, [{
        key: "componentDidCatch",
        value: function componentDidCatch(error, info) {
          // You can also do things like log the error to an error reporting service
          if (this.props.onError) {
            this.props.onError(error, info);
          }
        }
      }, {
        key: "render",
        value: function render() {
          var _this5 = this;

          if (this.state.error) {
            if (!this.props.errorType || this.state.error instanceof this.props.errorType) {
              return /*#__PURE__*/React__default['default'].createElement(StoreContext.Consumer, null, function (store) {
                return _this5.props.fallback({
                  error: _this5.state.error,
                  state: store.state,
                  actions: store.actions,
                  clearError: _this5.clearError
                });
              });
            } else {
              throw this.state.error;
            }
          } else {
            return this.props.children;
          }
        }
      }], [{
        key: "getDerivedStateFromError",
        value: function getDerivedStateFromError(error) {
          // Update state so the next render will show the fallback UI.
          return {
            error: error
          };
        }
      }]);

      return ErrorBoundary;
    }(React__default['default'].Component);

    _defineProperty(ErrorBoundary, "propTypes", {
      fallback: PropTypes__default['default'].func.isRequired,
      onError: PropTypes__default['default'].func,
      errorType: PropTypes__default['default'].object
    });

    var UseStore = /*#__PURE__*/function (_React$Component3) {
      _inherits(UseStore, _React$Component3);

      var _super4 = _createSuper(UseStore);

      function UseStore() {
        _classCallCheck(this, UseStore);

        return _super4.apply(this, arguments);
      }

      _createClass(UseStore, [{
        key: "render",
        value: function render() {
          var _this6 = this;

          return /*#__PURE__*/React__default['default'].createElement(StoreContext.Consumer, null, function (store) {
            return _this6.props.name ? _this6.props.children(store.read(_this6.props.name, _this6.props.item), store.actions) : _this6.props.children(store.actions);
          });
        }
      }]);

      return UseStore;
    }(React__default['default'].Component);

    _defineProperty(UseStore, "propTypes", {
      name: PropTypes__default['default'].string,
      item: PropTypes__default['default'].oneOfType([PropTypes__default['default'].string, PropTypes__default['default'].number, PropTypes__default['default'].bool, PropTypes__default['default'].symbol])
    });

    var exports = {
      Store: Store,
      ErrorBoundary: ErrorBoundary,
      UseStore: UseStore
    };

    if (React__default['default'].useContext) {
      var useStore = function useStore(name, item) {
        var store = React__default['default'].useContext(StoreContext);

        if (name) {
          return [store.read(name, item), store.actions];
        } else {
          return store.actions;
        }
      };

      exports["useStore"] = useStore;
    }

    return exports;
  };

  function logToConsole(type, _ref3) {
    var actionName = _ref3.actionName,
        payload = _ref3.payload,
        dispatchId = _ref3.dispatchId,
        initializing = _ref3.initializing,
        changes = _ref3.changes,
        result = _ref3.result,
        error = _ref3.error;

    switch (type) {
      case "initializing":
        console.log("%c".concat(type, " %c").concat(initializing, "%c%s %cwith %c").concat(actionName), "font-weight: bold;", "color: green; font-weight: bold;", "color: black; font-weight: bold;", payload ? "[\"".concat(payload, "\"]") : "", "color: black; font-weight: normal;", "color: blue; font-weight: bold;");
        break;

      case "dispatch":
        console.group("[".concat(dispatchId, "] ").concat(type, " %c").concat(actionName, "%c"), "color: blue;", "color: black");
        payload.forEach(function (arg) {
          return arg != null && console.log(arg);
        });
        console.groupEnd();
        break;

      case "executed":
        console.group("[".concat(dispatchId, "] ").concat(type, " %c").concat(actionName, "%c"), "color: blue;", "color: black");
        Object.keys(result).length > 0 && console.log(result);
        console.groupEnd();
        break;

      case "update":
        console.group("[".concat(dispatchId, "] ").concat(type, " %cfrom %c").concat(actionName, "%c"), "font-weight: normal;", "color: blue;", "color: black");
        changes.forEach(function (patch) {
          if (patch.path.length > 1) {
            console.groupCollapsed("%c".concat(patch.op, " %c").concat(patch.path.slice(0, patch.path.length - 1), "%c[\"").concat(patch.path[patch.path.length - 1], "\"]"), "font-weight: normal; font-style: italic;", "color: green", "color: black");
          } else {
            console.groupCollapsed("%c".concat(patch.op, " %c").concat(patch.path[0]), "font-weight: normal; font-style: italic;", "color: green");
          }

          console.log(patch.value);
          console.groupEnd();
        });
        console.groupEnd();
        break;

      case "error":
        console.groupCollapsed("[".concat(dispatchId, "] %c").concat(type, " %cin %c").concat(actionName), "color: red", "color: black; font-weight: normal;", "color: black");
        console.log(error);
        console.groupEnd();
        break;

      default:
        console.groupCollapsed("%c".concat(type, " %c").concat(actionName), "color: lightgrey", "color: black");
        console.log({
          actionName: actionName,
          payload: payload,
          dispatchId: dispatchId
        });
        console.groupEnd();
    }
  }

  var consoleLogger = function consoleLogger(action, _ref4) {
    var actionName = _ref4.actionName,
        initializing = _ref4.initializing,
        dispatchId = _ref4.dispatchId;
    return /*#__PURE__*/function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(store) {
        var _len5,
            payload,
            _key5,
            loggingStore,
            result,
            _args = arguments;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                for (_len5 = _args.length, payload = new Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
                  payload[_key5 - 1] = _args[_key5];
                }

                if (initializing) {
                  logToConsole("initializing", {
                    dispatchId: dispatchId,
                    actionName: actionName,
                    payload: payload,
                    initializing: initializing
                  });
                }

                loggingStore = _objectSpread2(_objectSpread2({}, store), {}, {
                  update: function update(mutator) {
                    return store.update(mutator).then(function (updateInfo) {
                      logToConsole("update", _objectSpread2({
                        dispatchId: dispatchId,
                        actionName: actionName,
                        payload: payload
                      }, updateInfo));
                      return updateInfo;
                    });
                  }
                });
                logToConsole("dispatch", {
                  dispatchId: dispatchId,
                  actionName: actionName,
                  payload: payload
                });
                _context.prev = 4;
                _context.next = 7;
                return action.apply(void 0, [loggingStore].concat(payload));

              case 7:
                result = _context.sent;
                logToConsole("executed", {
                  dispatchId: dispatchId,
                  actionName: actionName,
                  payload: payload,
                  result: result || {}
                });
                return _context.abrupt("return", result);

              case 12:
                _context.prev = 12;
                _context.t0 = _context["catch"](4);
                logToConsole("error", {
                  dispatchId: dispatchId,
                  actionName: actionName,
                  payload: payload,
                  error: _context.t0
                });
                throw _context.t0;

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[4, 12]]);
      }));

      return function (_x) {
        return _ref5.apply(this, arguments);
      };
    }();
  };

  exports.consoleLogger = consoleLogger;
  exports.default = createStore;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
